﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Lecture1.Models;

namespace Lecture1.Controllers
{
    public class DemoController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }


        [AcceptVerbs(HttpVerbs.Get | HttpVerbs.Post)]
        public ActionResult Submit(string text)
        {
            ViewBag.Text = text;
            return View();
        }


        public ActionResult Status()
        {
            return View();
        }


        public ActionResult StatusRedirect()
        {
            return RedirectToAction("Index");
        }


        public ActionResult StatusError()
        {
            throw new NotSupportedException();
        }


        [AcceptVerbs(HttpVerbs.Get | HttpVerbs.Post)]
        public ActionResult StateHiddenField(StateData data)
        {
            if (String.IsNullOrEmpty(data.Country))
            {
                return View("StateCountryStep");
            }

            if (String.IsNullOrEmpty(data.FullName))
            {
                return View("StateNameStepHiddenField", data);
            }

            return View("StateFinalStep", data);
        }


        [AcceptVerbs(HttpVerbs.Get | HttpVerbs.Post)]
        public ActionResult StateCookie(StateData data)
        {
            var countryCookie = Request.Cookies["StateDemoCountry"];
            var country = data.Country ?? (countryCookie != null ? countryCookie.Value : null);
            if (!String.IsNullOrEmpty(data.Country))
            {
                Response.Cookies.Add(new HttpCookie("StateDemoCountry", data.Country) { Expires = DateTime.Now.AddDays(1) });
            }      

            if (String.IsNullOrEmpty(country))
            {
                return View("StateCountryStep");
            }

            var fullNameCookie = Request.Cookies["StateDemoFullName"];
            var fullName = data.FullName ?? (fullNameCookie != null ? fullNameCookie.Value : null);
            if (!String.IsNullOrEmpty(data.FullName))
            {
                Response.Cookies.Add(new HttpCookie("StateDemoFullName", data.FullName) { Expires = DateTime.Now.AddDays(1) });
            }

            if (String.IsNullOrEmpty(fullName))
            {
                return View("StateNameStep");
            }

            return View("StateFinalStep", new StateData { Country = country, FullName = fullName });
        }


        [AcceptVerbs(HttpVerbs.Get | HttpVerbs.Post)]
        public ActionResult StateSession(StateData data)
        {
            var sessionData = (Session["StateDemo"] as StateData) ?? new StateData();
            sessionData.Country = sessionData.Country ?? data.Country;
            sessionData.FullName = sessionData.FullName ?? data.FullName;
            Session["StateDemo"] = sessionData;

            if (String.IsNullOrEmpty(sessionData.Country))
            {
                return View("StateCountryStep");
            }

            if (String.IsNullOrEmpty(sessionData.FullName))
            {
                return View("StateNameStep");
            }

            return View("StateFinalStep", sessionData);
        }
    }
}